% Los programas son para fines educativo y se ofrecen para uso publico 
% en educacin
% Dr. Carlos Barrn Romero
% Septiembre de 2019
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Programa para ejecutar un AFD
% Archivos de entrada
% EDos_final.txt: Archivo de estados finales como tabla de nmeros
global tam_tabla
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[file_ef,path1] = uigetfile('Edos_final.txt');
fileID = fopen(file_ef,'r');
tb_edoF = fscanf(fileID,'%d');
fclose(fileID);

% Tb_funTran.txt: Archivo de la tabla de la funcin de transicin
% Numero \tab simbolo \tab Numero.

[file_tb,path1] = uigetfile('Tb_funTran.txt');
fileID = fopen(file_tb,'r');
% Construye una tabla de estructura qe;numero,s:simbol,qs:numero
ctr=0;
tb_afd = textscan(fileID,'%d\t%c\t%d');
% tb_af{1}(i) qe: estado de entrada
% tb_af{2}(i) s : smbolo
% tb_af{3}(i) qr: estado resultante
fclose(fileID);
tam_tabla=length(tb_afd{1}); % Nmero total de estados
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

while(1)
    cadena=input('dar una cadena (T: terminar) => ','s');
    if (cadena=='T')
        break;
    end
    qa=0; % 0 es el estado inicial
    % analiza la cadena 
    for j=1:length(cadena)
        [qr]=f_automataFD(tb_afd,qa,cadena(j:j));
        if (qr==-1)
            break; % Termina porque no hay transicin valida
        else
            qa=qr; % actualiza el estado del AFD
        end
    end
    if (qr~=-1)&(find(tb_edoF==qr)) % es estado final?
        disp('Cadena aceptada');
    else
        disp('Cadena rechazada');
    end
end
